<!-- eslint-disable vue/multi-word-component-names -->
<template>
  <AppFlexCenterLayout
    class="h-full m-auto justify-between homepage:w-10/12 max-w-[100rem]"
  >
    <div class="ml-16 w-1/2 hidden homepage:block">
      <Astronaut
        class="w-full h-full max-w-[40rem] mr-auto"
      />
    </div>
    <AppFlexCenterLayout
      column
      class="small-homepage:m-8 homepage:ml-16 p-8 max-w-[40rem] homepage:w-1/2 w-full gap-8
        small-homepage:card small-homepage:bg-white small-homepage:shadow-2xl"
    >
      <div class="text-center homepage:text-left homepage:text-white">
        <h1 class="mb-4 text-9xl font-bold">
          {{ error.statusCode }}
        </h1>
        <h2 class="mb-4 text-5xl font-bold">
          {{ $t(`errorPage.${errorType}.title`) }}
        </h2>
        <h4 class="homepage:w-4/5 text-lg">
          {{ $t(`errorPage.${errorType}.paragraph`) }}
        </h4>
      </div>
      <div
        class="flex flex-col homepage:place-self-start gap-4"
      >
        <button
          class="btn btn-primary homepage:bg-white homepage:hover:bg-white
            homepage:text-primary w-64"
          @click="() => navigateTo('/')"
        >
          {{ $t(`errorPage.${errorType}.homeLink`) }}
        </button>
      </div>
    </AppFlexCenterLayout>
  </AppFlexCenterLayout>
</template>

<script lang='ts'>
import { defineComponent } from '@nuxtjs/composition-api'
import gsap from 'gsap'
import Astronaut from '../assets/images/astronaut.svg?inline'

export default defineComponent({
  components: { Astronaut },
  layout: 'error',
  props: { error: { type: Object, default: () => ({}) } },
  computed: {
    errorType():string {
      return this.error?.statusCode === 404 ? 'pageNotFound' : 'fallback'
    }
  },
  mounted() {
    const timeline = gsap.timeline()

    timeline.set('svg', { visibility: 'visible' })
    timeline.to('#headStripe', {
      y: 0.5,
      rotation: 1,
      yoyo: true,
      repeat: -1,
      ease: 'sine.inOut',
      duration: 1
    })
    timeline.to('#spaceman', {
      y: 0.5,
      rotation: 1,
      yoyo: true,
      repeat: -1,
      ease: 'sine.inOut',
      duration: 1
    })
    timeline.to('#craterSmall', {
      x: -3,
      yoyo: true,
      repeat: -1,
      duration: 1,
      ease: 'sine.inOut'
    })
    timeline.to('#craterBig', {
      x: 3,
      yoyo: true,
      repeat: -1,
      duration: 1,
      ease: 'sine.inOut'
    })
    timeline.to('#planet', {
      rotation: -2,
      yoyo: true,
      repeat: -1,
      duration: 1,
      ease: 'sine.inOut',
      transformOrigin: '50% 50%'
    })

    timeline.to('#starsBig g', {
      rotation: 'random(-30,30)',
      transformOrigin: '50% 50%',
      yoyo: true,
      repeat: -1,
      ease: 'sine.inOut'
    })
    timeline.fromTo(
      '#starsSmall g',
      { scale: 0, transformOrigin: '50% 50%' },
      { scale: 1, transformOrigin: '50% 50%', yoyo: true, repeat: -1, stagger: 0.1 }
    )
    timeline.to('#circlesSmall circle', {
      y: -4,
      yoyo: true,
      duration: 1,
      ease: 'sine.inOut',
      repeat: -1
    })
    timeline.to('#circlesBig circle', {
      y: -2,
      yoyo: true,
      duration: 1,
      ease: 'sine.inOut',
      repeat: -1
    })

    timeline.set('#glassShine', { x: -68 })

    timeline.to('#glassShine', {
      x: 80,
      duration: 2,
      rotation: -30,
      ease: 'expo.inOut',
      transformOrigin: '50% 50%',
      repeat: -1,
      repeatDelay: 8,
      delay: 2
    })
  }
})
</script>
